SystemOrganization addCategory: #'TpFinalSquash-Core'!
SystemOrganization addCategory: #'TpFinalSquash-TestCases'!

Object subclass: #Club
	instanceVariableNames: 'nombre jugadores partidos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!Club class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 01:36'!
nuevoConNombre:nombreClub
"Crea un nuevo club"
	^ (self new) nombre: nombreClub ! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:10'!
agregarJugador: nombreJugador conRanking:ranking  fecha: enFecha
| jugador |
"Envia mensaje a la clase Jugador para crear un nuevo jugador y lo carga en la coleccion de jugadores(variable de instancia) de la clase club"
	jugador := self buscarJugador: nombreJugador.
	
	(jugador isNil)
		ifTrue: [jugadores add: (Jugador nuevoJugador: nombreJugador  ranking: ranking fecha: enFecha)]! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:42'!
agregarPartidoEntre: nombreJugador1 y: nombreJugador2 fecha: unaFecha resultado: unVector
| jugadorLocal1 rankingJ1 g1 jugadorLocal2  rankingJ2 g2|
"Agrega partido a las coleccion partidos(variable de instancia) , desde aqui se envia el mensaje al partido para 
crear el partido, tambien se le envia mensaje a cada jugador del partido en el que acaba de participar asi lo almacena en su historico de partidos y se genera el ranking correspondiente"

	jugadorLocal1 := self buscarJugador: nombreJugador1.
	jugadorLocal2 := self buscarJugador: nombreJugador2.

	((jugadorLocal1 validarRankingEn: unaFecha ) & (jugadorLocal2 validarRankingEn: unaFecha  ))
	ifTrue: 
	[
		g1 := unVector at: 1.
		g2 := unVector at: 2.
		partidos add: (Partido agregarPartidoEntre: jugadorLocal1 y: jugadorLocal2 fecha: unaFecha  gamesJugador1: g1 gamesJugador: g2 ).
	
		rankingJ1:= ((jugadorLocal1 buscarRankingfecha: unaFecha) ranking ) . rankingJ2:= ((jugadorLocal2 buscarRankingfecha: unaFecha) ranking).
		jugadorLocal1 agregarPartido: (partidos last) rankingActualJ1: rankingJ1 rankingActualJ2: rankingJ2 .
		jugadorLocal2 agregarPartido: (partidos last) rankingActualJ1: rankingJ1 rankingActualJ2: rankingJ2 .
	]! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:45'!
asignarRanking: nuevoRanking nombre: nombreJugador fecha: enFecha
| jugador |
"Envia mensaje al Jugador para asignar un ranking en una fecha determinada"

	jugador := self buscarJugador: nombreJugador.
	(jugador ifNotNil:
		[
			(jugador validarRankingEn: enFecha)
				ifTrue: 
					[jugador asignarRanking: nuevoRanking fecha: enFecha]
		]
	)	
	

	
	
! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/29/2013 21:34'!
buscarJugador: nombreJugador
"Busca un jugador por su nombre en la coleccion de jugadores(variable de instancia)"
	^ jugadores detect: [:each | (each name ) = nombreJugador] ifNone:[^ nil]! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:16'!
buscarPartidoEntre: nombreJugador1 y: nombreJugador2 fecha: enFecha
"Busca un partido por su fecha y oponentes en la coleccion de partidos(variable de instancia)"
	^ partidos detect: [:each | (((each esIgualFecha: enFecha) & (each jugador1 name = nombreJugador1)) & (each jugador2 name = nombreJugador2 ))] ifNone:[nil].! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:47'!
buscarRanking: nombreJugador fecha: enFecha
| jugador rankingSalida |
"Envia un mensaje al jugador para pedirle su ranking en una determinada fecha"	
	jugador := self buscarJugador: nombreJugador.
	
	(jugador ifNotNil: 
		[	^ rankingSalida := (jugador buscarRankingfecha: enFecha ) ranking ]
	)! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:50'!
editarPartidoEntre: nombreJugador1 y: nombreJugador2 fecha: enFecha nuevoResultado: nuevoResultado nuevafecha: nuevaFecha
| partido |
"Edita el partido entre 2 jugadores en la fecha especificada en la coleccion partidos(variable de instancia) luego envia mensaje a cada jugador del partido para que actualicen sus ranking dependientes"
			
	partido := self buscarPartidoEntre: nombreJugador1 y: nombreJugador2 fecha: enFecha.
	(partido ifNotNil: 
		[
			((partido jugador1 validarEditarRankingPartidoEn: enFecha a: nuevaFecha) & (partido jugador2 validarEditarRankingPartidoEn: enFecha a: nuevaFecha))
			ifTrue: [
				partido gamesJugador1: (nuevoResultado at: 1) gamesJugador2: (nuevoResultado at: 2)  fecha: nuevaFecha.
				partidos reSort.		
				"Envia mensaje a los oponentes del partido para que actualicen sus ranking dependientes"
				partido jugador1 editarPartido: enFecha  nuevafecha: nuevaFecha.
				partido jugador2 editarPartido: enFecha  nuevafecha: nuevaFecha 
			]
		]
	)! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:02'!
editarRankingDe: nombreJugador fecha: enFecha ranking: nuevoRanking nuevaFecha: nuevaFecha
|jugador|
"Envia mensaje a un jugador para editar un ranking en una fecha determinada"
	jugador  := self buscarJugador: nombreJugador.
	
	(jugador ifNotNil: 	
		[
			(jugador validarEditarRankingAsignadoEn: enFecha a: nuevaFecha)
				ifTrue: 
					[jugador editarRankingFecha: enFecha  ranking: nuevoRanking  nuevaFecha: nuevaFecha]
		]
	)
	! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 13:36'!
eliminarPartidoEntre: nombreJugador1 y: nombreJugador2 fecha: enFecha
| jugadorLocal1 g1 jugadorLocal2 g2 rankingJ1 rankingJ2 partidoLocal|
"Elimina de la coleccion de partidos(variable de instancia) el partido especificado,se le envia mensaje a cada jugador del partido para que eliminen el dicho de su historico y actualice sus ranking si es necesario"

	jugadorLocal1 := jugadores detect: [:each | each name = nombreJugador1 ].
	jugadorLocal2 := jugadores detect: [:each | each name = nombreJugador2 ].

	partidos do: [:partido | ((partido fecha = enFecha) & (partido jugador1 = jugadorLocal1 & partido jugador2 = jugadorLocal2))
		 			ifTrue: [ partidoLocal:= partido.partidos remove: partido ] 
					].

	rankingJ1:= ((jugadorLocal1 buscarRankingAnteriorfecha: enFecha ) ranking ) . rankingJ2:= ((jugadorLocal2 buscarRankingAnteriorfecha: enFecha) ranking).
	jugadorLocal1 eliminarPartido: partidoLocal rankingActualJ1: rankingJ1 rankingActualJ2: rankingJ2 .
	jugadorLocal2 eliminarPartido: partidoLocal rankingActualJ1: rankingJ1 rankingActualJ2: rankingJ2! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:58'!
eliminarRankingDe: nombreJugador fecha: enFecha
| jugador rankingSalida|	
"Envia mensaje a un jugador para eliminar un ranking de una determinada fecha"	
	jugador := self buscarJugador: nombreJugador.
	
	(jugador ifNotNil: 
		[jugador eliminarRankingfecha: enFecha]
	)
	! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:06'!
initialize 
"Inicializa colecciones"
	"Coleccion de jugadores registrados en el club"
	jugadores := SortedCollection sortBlock: [:predecessor :successor| predecessor rankings last ranking  >= successor rankings last ranking].
	"Coleccion de partidos jugados en el club"
	partidos  := SortedCollection sortBlock: [:predecessor :successor| predecessor fecha  <= successor fecha].! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
jugadores
"es un metodo de prueba"
^ jugadores ! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:27'!
jugadoresCercanos: nombreJugador valor: unValor
| jugador rankingJugador rangoSuperior rangoInferior salida|
"Retorna jugadores cuyo ranking actual se encuentran por encima o
por debajo del ranking actual del jugador en cuestion no mas del valor ingresado"
	jugador  := self buscarJugador: nombreJugador.
	salida := OrderedCollection new.
		(jugador ifNotNil:
			[
				(rankingJugador := jugador rankingActual).
				((rankingJugador)  ifNotNil:
					[
					rangoInferior:= (rankingJugador ranking - unValor ).
			 		rangoSuperior := (rankingJugador ranking + unValor).		
			  	(jugadores select: [:each | ((each rankingActual ranking  >= rangoInferior) & (each rankingActual ranking   <= rangoSuperior) ) ]) do: 				[:each1 | ( each1 name  ~= jugador name   ifTrue: [ salida add: each1 ] )].			
						^ salida
					]
				)
			]
		)! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
nombre
	^ nombre ! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
nombre:unNombre
	nombre := unNombre ! !

!Club methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:02'!
partidos 
	^ partidos ! !

!Club methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:14'!
rankingJugadoresEntre: valorInferior y: valorSuperior
| coleccionJugadores |
coleccionJugadores := OrderedCollection new.
"Recorre la coleccion de jugadores y a cada jugador le va preguntando si su ranking actual esta dentro del rango especificado"

(valorInferior isNil)
	ifTrue: [
				(valorSuperior isNil)
				ifTrue: [^ jugadores select: [:each | ((each rankingActual ranking) >= 0)]]
				ifFalse: [^ jugadores select: [:each | (((each rankingActual ranking) >= 0) & ((each rankingActual ranking) <= valorSuperior)) ]]
		]
	ifFalse: [
				(valorSuperior isNil)
				ifTrue: [^ jugadores select: [:each | ((each rankingActual ranking) >= valorInferior)]]
				ifFalse: [^ jugadores select: [:each | (((each rankingActual ranking) >= valorInferior) & ((each rankingActual ranking) <= valorSuperior)) ]]
		
		]


! !

Object subclass: #Jugador
	instanceVariableNames: 'name partidos rankings partidosActualizados'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!Jugador class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 21:26'!
nuevoJugador: nombreJugador ranking: unRanking fecha: enFecha
"Crea un nuevo jugador"
	^ (self new) jugador: nombreJugador  fecha: enFecha  ranking: unRanking 
	
	! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:53'!
actualizarRanking: unaFecha
| rankingAntOponente partidoActual raj1Anterior raj2Anterior|
"Actualiza rankings dependientes del jugador actual despues de una determinada accion (eliminar, crear,asignar,editar rankings y partidos) apartir de la fecha recibida y enviara mensajes al oponente para que actialicen sus respectivos rankings"
	rankings do: [:ranking | ((ranking fecha >= unaFecha) & (ranking partido = true)) 
		 ifTrue: [ partidoActual := (self buscarPartidoFecha: ranking fecha).
			((self buscarPartidoListo: partidoActual) = true)
			ifFalse: [ 
				ranking actualizarRanking: partidoActual  coleccion: partidosActualizados jugador: self 
				
			]			 ]			].

	partidosActualizados do: [:partido | partidosActualizados remove: partido ]! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:51'!
agregarPartido: unPartido rankingActualJ1: raj1 rankingActualJ2: raj2 
| rna |
"Agrega un partido a la coleccion de partidos(variable de instancia) crea el ranking correspondiente y actualiza los ranking dependientes si es necesario"
	partidos add: unPartido.
			
	(self name = (unPartido jugador1 name ))
			ifTrue: [
				rna := (Ranking obtenerRankingGamesA:(unPartido gamesJugador1)  gamesB:(unPartido gamesJugador2)  rActualJa:raj1  rActualJb: raj2)	
		     ]
	ifFalse:[
				rna := (Ranking obtenerRankingGamesA:(unPartido gamesJugador2)  gamesB:(unPartido gamesJugador1)  rActualJa:raj2  rActualJb: raj1)	
			].
	
	rankings add: (Ranking nuevoPartidoRanking: rna fecha: (unPartido fecha)).
	self actualizarRanking: (unPartido fecha)! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:50'!
asignarRanking: unRanking fecha: enFecha
| rankingSalida |
"Agrega ranking en la coleccion de rankings(variable de instancia) y actualiza los ranking dependientes si es necesario"
	
	rankings add: (Ranking nuevoAsignadoRanking: unRanking fecha: enFecha).
	self actualizarRanking: enFecha! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:45'!
buscarPartidoFecha: enFecha
"Busca un partido por su fecha en la coleccion de partidos(variable de instancia)"
^ partidos detect: [:each | each esIgualFecha: enFecha ] ifNone:[nil]
! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:36'!
buscarPartidoListo: unPartido
|salida|
"Busca un partido en la coleccion de partidosActualiados(variable de instancia)"

partidosActualizados do: [:each | (each = unPartido ) ifTrue: [^ true]].
^ false


! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:44'!
buscarRankingAnteriorfecha: unaFecha
| rankingSalida coleccionAux |
"Recorre los ranking(variable de instancia) del jugador y retorna el ranking anterior a la fecha especificada"

	coleccionAux := OrderedCollection new.

				rankings do: [:each | ( each fecha < unaFecha)
												ifTrue: [coleccionAux add: each]
									  ]	.
	^ coleccionAux last.
	
	
	! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:34'!
buscarRankingfecha: enFecha
| rankingSalida coleccionAux |
"Retorna el ranking del jugador que coincida con la fecha recibida por parametro si no coinciden las fechas se retorna el ranking anterior"

	coleccionAux := OrderedCollection new.
	rankingSalida := rankings detect: [:ranking | ranking esIgualFecha: enFecha ] ifNone:[nil].
	(rankingSalida  isNil)
	 ifTrue:  [ 	^ self buscarRankingAnteriorfecha: enFecha ]
	 ifFalse: [	^ rankingSalida ] 
	
	
	! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:16'!
editarPartido: enFecha nuevafecha: nuevaFecha
| partido ranking |
"Reordena los partidos del jugador, edita el ranking correspondiente y actualiza los ranking dependientes si es necesario"	
	partidos reSort.
	partido := self buscarPartidoFecha: nuevaFecha.
	
	(partido ifNotNil: 
		[
				ranking := self buscarRankingfecha: enFecha.
				(ranking ifNotNil:
						[
							ranking fecha: nuevaFecha.
							rankings reSort.
							(enFecha <= nuevaFecha )
							ifTrue: [ self actualizarRanking: enFecha]
							ifFalse: [ self actualizarRanking: nuevaFecha]
						]
				)
		]
	)! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:13'!
editarRankingFecha: enFecha ranking: nuevoRanking nuevaFecha: nuevaFecha
| ranking |	
"Edita en la coleccion de rankings(variable de instancia) del jugador un ranking , actualiza rankings dependientes si es necesario"
	
	ranking := self buscarRankingfecha: enFecha.
	
	(ranking ifNotNil:
				[
					ranking ranking: nuevoRanking.ranking fecha: nuevaFecha.
					rankings reSort.
					(enFecha <= nuevaFecha )
					ifTrue: [ self actualizarRanking: enFecha]
					ifFalse: [ self actualizarRanking: nuevaFecha]
				]
	)! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:26'!
eliminarPartido: unPartido rankingActualJ1: raj1 rankingActualJ2: raj2 
"Elimina de partidos(variable de instancia) el partido especificado y actualiza rankings dependientes si es necesario"

	partidos do: [:partido | (partido = unPartido) ifTrue: [ partidos remove: partido ] ].		
	rankings do: [:ranking | (ranking esIgualFecha: (unPartido fecha)) ifTrue: [ rankings remove: ranking ] ].

	self actualizarRanking: (unPartido fecha)! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:23'!
eliminarRankingfecha: enFecha
"Recorro los rankings(variable de instancia) del jugador y elimina el ranking de la fecha especificada, actualiza rankings dependientes si es necesario"

	rankings do: [:ranking | (ranking esIgualFecha: enFecha) ifTrue: [ rankings remove: ranking ] ].
	
	self actualizarRanking: enFecha! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:07'!
initialize
"Inicializa colecciones"
	"Coleccion de partidos donde el jugador participo"
	partidos  := SortedCollection sortBlock: [:predecessor :successor| predecessor fecha  <= successor fecha].
	"Coleccion de rankings del jugador"
	rankings := SortedCollection sortBlock: [:predecessor :successor| predecessor fecha  <= successor fecha].
	"Coleccion que el jugador utiliza para guardar los partidos con los que ya actualizo uno de sus rankings y asi evitar procesar mas de una vez un partido si su oponente le envia mensaje para que actualice sus rankings"
	partidosActualizados  := OrderedCollection new! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 21:51'!
jugador: nombreJugador fecha: enFecha ranking: unRanking
"Asigna el nombre del nuevo jugador e inicializa rankings(variable de instancia) con el ranking y la fecha inicial"
	
	name:= nombreJugador.
	
	rankings add: (Ranking nuevoAsignadoRanking: unRanking fecha: enFecha).
	! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 21:50'!
name
"Retorna nombre del jugador"
	^ name ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 21:50'!
partidoValidoActualizar: enFecha
"Valida si un partido del jugador ya actualizo su ranking correspondiente"
| partidoActual|
			partidoActual := (self buscarPartidoFecha: enFecha).
			^ self buscarPartidoListosFecha: partidoActual! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/29/2013 21:48'!
partidos
	^ partidos ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 21:48'!
partidosActualizados
"Retorna lista de partidos actualizados del jugador"
	^ partidosActualizados ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:12'!
rankingActual
"Retorna ranking actual del jugador"
	^ self rankings last! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 21:48'!
rankingInicial
"Retorna ranking inicial del jugador"
	^ self rankings first! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/20/2013 17:10'!
rankings 
	^ rankings ! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:24'!
validarEditarRankingAsignadoEn: enFecha a: nuevaFecha
| rankingEditar |
"Valida editar un partido"
(enFecha = nuevaFecha )
	ifTrue: [
		rankings do: [:each | 
						((each esIgualFecha: enFecha) & (each partido = false))
								ifTrue: [	^ true	]
				].
		^ false
	]
	ifFalse: [
		rankingEditar := rankings detect: [:each | ((each esIgualFecha: enFecha) & (each partido = false))] ifNone:[^ nil].
		(rankingEditar ifNotNil:
			[
				^  self validarRankingEn: nuevaFecha.
			]
		).
		^ false
	]! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:24'!
validarEditarRankingPartidoEn: enFecha a: nuevaFecha
| rankingEditar |
"Valida editar un ranking asignado por el administrador"
(enFecha = nuevaFecha )
	ifTrue: [
		rankings do: [:each | 
						((each esIgualFecha: enFecha) & (each partido = true))
								ifTrue: [	^ true	]
				].
		^ false
	]
	ifFalse: [
		rankingEditar := rankings detect: [:each | ((each esIgualFecha: enFecha) & (each partido = true))] ifNone:[^ nil].
		(rankingEditar ifNotNil:
			[
				^  self validarRankingEn: nuevaFecha.
			]
		).
		^ false
	]! !

!Jugador methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 22:25'!
validarRankingEn: enFecha
"Valida agregar o editar un ranking por un partido o desicion de un administrador"

(self rankingInicial fecha >= enFecha )
		ifTrue: [
						^ false
				].

rankings do: [:each | 
						(each esIgualFecha: enFecha )
								ifTrue: [
											^ false
								]
				].
^ true! !

Object subclass: #Partido
	instanceVariableNames: 'jugador1 jugador2 fecha gamesJugador1 gamesJugador2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!Partido class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:38'!
agregarPartidoEntre: jugador1 y: jugador2 fecha: enFecha  gamesJugador1: g1 gamesJugador: g2
"Crea un partido"
	^ (self new) jugador1: jugador1 jugador2: jugador2 fecha: enFecha gamesJugador1: g1 gamesJugador2: g2 
! !

!Partido methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:32'!
= partido
"Retorna si es partido es igual a otro"
	(self fecha ~= partido fecha) ifTrue: [^ false].
	(self jugador1 name  ~= partido jugador1 name) ifTrue: [^ false].
	(self gamesJugador1  ~= partido gamesJugador1) ifTrue: [^ false].
	(self jugador1 rankings size  ~= partido jugador1 rankings size) ifTrue: [^ false].
	(self jugador2 name  ~= partido jugador2 name) ifTrue: [^ false].
	(self gamesJugador2  ~= partido gamesJugador2) ifTrue: [^ false].
	(self jugador2 rankings size  ~= partido jugador2 rankings size) ifTrue: [^ false].
	
	^ true
	! !

!Partido methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:34'!
esIgualFecha: unaFecha
"Retorna si el partido tiene la fecha especificada"
	^ self fecha = unaFecha ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:34'!
fecha
"Retorna fecha del partido"
	^ fecha ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:35'!
gamesJugador1 
"Retorna games del jugador1"
	^ gamesJugador1 ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:37'!
gamesJugador1: nuevoGamesJugador1 gamesJugador2: nuevoGamesJugador2 fecha: nuevaFecha
"Asigna los games de cada jugador y la fecha del patido a las variables de instancia"
	gamesJugador1:=nuevoGamesJugador1.
	gamesJugador2:=nuevoGamesJugador2.
	fecha:=nuevaFecha  ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:37'!
gamesJugador2
"Retorna games del jugador2"
	^ gamesJugador2 ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:37'!
jugador1
"Retorna al jugador1"
	^ jugador1 ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:37'!
jugador1: nombreJugador1 jugador2: nombreJugador2 fecha: enFecha gamesJugador1: nuevoGamesJugador1 gamesJugador2: nuevoGamesJugador2
"Asigna los jugadores los games de cada jugador y la fecha del patido a las variables de instancia"
	jugador1:= nombreJugador1.
	jugador2:= nombreJugador2.
	gamesJugador1:=nuevoGamesJugador1.
	gamesJugador2:=nuevoGamesJugador2.
	fecha:=enFecha  ! !

!Partido methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:38'!
jugador2
"Retorna al jugador2"
	^ jugador2 ! !

Object subclass: #Ranking
	instanceVariableNames: 'fecha ranking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

Ranking subclass: #AsignadoRanking
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!AsignadoRanking methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:44'!
partido
"Retorna si el ranking es resultado de un partido"
	^ false! !

Ranking subclass: #PartidoRanking
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!PartidoRanking methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/1/2013 23:31'!
actualizarRanking: partido coleccion: partidosActualizados jugador: jugador
"Actualiza un ranking con el valor resultante de un partido"
|raj1Anterior raj2Anterior|
				(jugador name = (partido jugador1 name ))			
				ifTrue: [
				raj1Anterior:=  (jugador buscarRankingAnteriorfecha: partido fecha) ranking.
				raj2Anterior:= ((partido jugador2  buscarRankingAnteriorfecha: partido fecha) ranking).
				self ranking: (Ranking obtenerRankingGamesA: (partido gamesJugador1) gamesB:(partido gamesJugador2)  rActualJa: raj1Anterior  rActualJb: raj2Anterior			).			
				partidosActualizados add: partido . partido jugador2 actualizarRanking:(partido fecha)
				]
				ifFalse: [
				raj2Anterior:=  (jugador buscarRankingAnteriorfecha: partido fecha) ranking.
				raj1Anterior:= ((partido jugador1  buscarRankingAnteriorfecha: partido fecha) ranking).
				self ranking: (Ranking obtenerRankingGamesA: (partido gamesJugador2) gamesB:(partido gamesJugador1)  rActualJa: raj2Anterior  rActualJb: raj1Anterior	).	
				partidosActualizados add: partido .	partido jugador1 actualizarRanking:(partido fecha)				
				]	! !

!PartidoRanking methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:44'!
partido
"Retorna si el ranking es resultado de un partido"
	^ true! !

!Ranking class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:39'!
nuevoAsignadoRanking: unRanking fecha: enFecha
"Crea un ranking asignado por un administrador"
	^ (AsignadoRanking new) ranking: unRanking; fecha: enFecha  ! !

!Ranking class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:39'!
nuevoPartidoRanking: unRanking fecha: enFecha
"Crea un ranking resultado de un partido entre 2 jugadores"
	^ (PartidoRanking new) ranking: unRanking; fecha: enFecha! !

!Ranking class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:40'!
obtenerRankingGamesA: ga gamesB: pa rActualJa: aRanking rActualJb: bRanking 
| rna ra ka gaa  sa ea ea1 paa rb |
"Retorna el valor del nuevo ranking aplicando la formula, esta formula se aplica a los aponentes de un partido esto dependiendo del orden de los parametros al momento de enviar el mensaje"
		     ra:= aRanking.
			  (ra < 1500)
							ifTrue: [ ka := 32]
							ifFalse: [ (ra > 1900) 
														ifTrue: [ka:= 16]
														ifFalse: [ka:=24]										
								].
			  (ga > pa ) ifTrue: [sa := 1] ifFalse: [sa := 0].
			  rb :=  bRanking . 
			
			ea1 := (( rb - ra) / 400). 	ea := (1 / ( 1 + (10 raisedTo: ea1))) roundTo: 0.000001.	
			rna := (ra + (ka * (sa - ea)) + ga - pa) roundTo: 0.000001 .
			^ rna! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:40'!
esIgualFecha: unaFecha
"Retorna si el ranking tiene la fecha especificada"
	^ self fecha = unaFecha ! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:41'!
fecha
"Retorna fecha del ranking"
	^ fecha! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:42'!
fecha: unafecha
"Asigna fecha al ranking"
	fecha := unafecha! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:43'!
partido
"Identifica si un ranking es resultado de un partido"
	^ false! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:42'!
ranking
"Retorna valor del ranking"
	^ ranking ! !

!Ranking methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:43'!
ranking: unNumero
"Asigna valor al ranking"
	ranking := unNumero ! !

Object subclass: #SquashSystem
	instanceVariableNames: 'club'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-Core'!

!SquashSystem class methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 01:42'!
newWithName: unNombre
"Crea instancia del Sistema y envia mensaje a si mismo con el nombre para crear el nuevo club"
	^ self new club: unNombre 
	  
	! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:24'!
addMatchBetween: jugador1 and: jugador2 at: enFecha withResult: resultadoGames
"Envia mensaje al club para que procese el ingreso de un nuevo partido"
	self club agregarPartidoEntre: jugador1 y: jugador2 fecha: enFecha  resultado: resultadoGames ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:08'!
addPlayer: nombreJugador withRanking: ranking  at: enFecha
"Envia mensaje al club para que procese el ingreso de un nuevo jugador"
	self club agregarJugador: nombreJugador conRanking: ranking fecha: enFecha
! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/31/2013 00:53'!
assignRanking: unNumero to: unNombre at: enFecha
"Envia mensaje al club para que procese la asignacion de un ranking a un jugador en una determinada fecha"
	self club asignarRanking: unNumero nombre: unNombre fecha: enFecha! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/19/2013 15:44'!
club 
"Retorna el club actual"
	^ club ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/31/2013 00:58'!
club: nombreClub
"Envia mensaje para crear un nuevo club"
	club:= (Club nuevoConNombre: nombreClub )! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:57'!
deleteMatchBetween: jugador1 and: jugador2 at: enFecha
"Envia mensaje al club para que elimine un partido en una determinada fecha"
	self club eliminarPartidoEntre: jugador1 y: jugador2  fecha: enFecha ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/3/2013 23:58'!
deleteRankingOf: nombreJugador at: enFecha
"Envia mensaje al club para que elimine un ranking de un jugador en una determinada fecha"
	self club eliminarRankingDe: nombreJugador  fecha: enFecha ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/29/2013 17:23'!
editMatchBetween:jugador1 and:jugador2 at: unaFecha withNewResult:unResultado andNewDate: unaNuevaFecha
"Envia mensaje al club para que edite el resultado de un partido"
	self club editarPartidoEntre: jugador1 y:jugador2  fecha: unaFecha  nuevoResultado: unResultado  nuevafecha: unaNuevaFecha ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'TomasJhon 8/4/2013 00:02'!
editRankingOf: nombreJugador at: enFecha withNewValue: nuevoRanking andNewDate: nuevaFecha
"Envia mensaje al club para que edite el ranking de un jugador en una determinada fecha"
	self club editarRankingDe: nombreJugador fecha: enFecha ranking: nuevoRanking nuevaFecha: nuevaFecha
! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/29/2013 17:24'!
edithMatchBetween: jugador1 and:jugador2 at: unaFecha withNewResult:unResultado andNewDate: unaNuevaFecha
"Envia mensaje al club para que edite un partido en una determinada fecha"
	self club editarPartidoEntre: jugador1 y:jugador2  fecha: unaFecha  nuevoResultado: unResultado  nuevafecha: unaNuevaFecha ! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/19/2013 14:53'!
initialize 
	" inicializa variables de instancia "
	" clubes := OrderedCollection new "
	! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/29/2013 17:24'!
playersNear: nombreJugador by: unValor
"Envia mensaje al club para buscar jugadores cuyo ranking actual se encuentren dentro del rango especificado "
	^ self club jugadoresCercanos: nombreJugador  valor: unValor! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/29/2013 17:24'!
playersRankedBetween: valorInferior and: valorSuperior
"Envia mensaje al club para buscar jugadores cuyo ranking actual se encuentren dentro del rango especificado "
	^ self club rankingJugadoresEntre: valorInferior y: valorSuperior 
! !

!SquashSystem methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/29/2013 17:24'!
rankingOf: nombreJugador at: unaFecha
"Envia mensaje al club para buscar el ranking de un jugador en una determinada fecha"
	^ self club buscarRanking: nombreJugador  fecha: unaFecha ! !

TestCase subclass: #TestCaseSquashTp
	instanceVariableNames: 'squashSystem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TpFinalSquash-TestCases'!

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/17/2013 18:39'!
setUp 
	squashSystem := SquashSystem newWithName: 'La Plata Squash Club'.
	
	squashSystem addPlayer: 'Ralph' withRanking: 1400 at: '2013-06-01' asDateAndTime.
	squashSystem addPlayer: 'Gail' withRanking: 2000 at: '2013-06-01' asDateAndTime.
	squashSystem addPlayer: 'Henry' withRanking: 1600 at: '2013-06-01' asDateAndTime.
	squashSystem addPlayer: 'Mark' withRanking: 1000 at: '2013-06-01' asDateAndTime.	
	squashSystem addPlayer: 'George' withRanking: 800 at: '2013-06-05' asDateAndTime.
	
	squashSystem addMatchBetween: 'Ralph' and: 'Gail' at: '2013-06-03' asDateAndTime withResult: #(3 2).
	squashSystem addMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime withResult: #(3 0).
	squashSystem addMatchBetween: 'Gail' and: 'Henry' at: '2013-06-05' asDateAndTime withResult: #(1 3).
	squashSystem addMatchBetween: 'Henry' and: 'George' at: '2013-06-07' asDateAndTime withResult: #(3 1).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/19/2013 13:43'!
test01

	self assert: ((squashSystem rankingOf: 'Henry' at: '2013-06-06' asDateAndTime) closeTo: 1627.311424).
	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1629.514771).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-06' asDateAndTime) closeTo: 800).	
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7288709).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-06' asDateAndTime) closeTo: 1967.106627).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1967.106627).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/17/2013 18:39'!
test02

	squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1625.829881).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7231018).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-04' asDateAndTime) closeTo: 1983.490455).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1967.07565).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/18/2013 11:17'!
test03

	squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.
 	squashSystem assignRanking: 1600 to: 'Gail' at: '2013-06-04' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1616.219393).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7074759).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-04' asDateAndTime) closeTo: 1600).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1586).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/25/2013 17:41'!
test04
	
   squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.
   squashSystem assignRanking: 1600 to: 'Gail' at: '2013-06-04' asDateAndTime.
   squashSystem deleteRankingOf: 'Gail' at: '2013-06-04' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 1625.829881).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.7231018).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-04' asDateAndTime) closeTo: 1983.490455).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1967.07565).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/25/2013 17:41'!
test05

	squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.
	squashSystem assignRanking: 1600 to: 'Gail' at: '2013-06-04' asDateAndTime.	
 	squashSystem editRankingOf: 'Henry' at: '2013-06-01' asDateAndTime withNewValue: 800 andNewDate: '2013-06-01' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'Henry' at:'2013-06-08' asDateAndTime) closeTo: 850.1368426).
	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 783.5463257).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-04' asDateAndTime) closeTo: 1600).
	self assert: ((squashSystem rankingOf: 'Gail' at:'2013-06-08' asDateAndTime) closeTo: 1574.237624).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/19/2013 11:52'!
test06

	squashSystem deleteMatchBetween: 'Henry' and: 'Mark' at: '2013-06-03' asDateAndTime.
	squashSystem assignRanking: 1600 to: 'Gail' at: '2013-06-04' asDateAndTime.
 	squashSystem editMatchBetween: 'Gail' and: 'Henry' at: '2013-06-05' asDateAndTime withNewResult: #(3 0) andNewDate: '2013-06-05' asDateAndTime.

	self assert: ((squashSystem rankingOf: 'George' at:'2013-06-08' asDateAndTime) closeTo: 797.654903154728).! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'tomasJhon 7/18/2013 09:30'!
test07

	| playersCollection |

	playersCollection := squashSystem playersRankedBetween: 800 and: 1500.
	self assert: playersCollection size equals: 2.
	self assert: ((playersCollection at:1) name = 'Ralph').
	self assert: ((playersCollection at:2) name = 'Mark').! !

!TestCaseSquashTp methodsFor: 'as yet unclassified' stamp: 'TomasJhon 7/11/2013 01:11'!
test08

	| playersCollection |

	playersCollection := squashSystem playersNear:'Mark' by: 300.
	self assert: playersCollection size equals: 1.
	self assert: ((playersCollection at:1) name = 'George').

! !
